Index: trunk/AGRIF/LIB/fortran.y
===================================================================
--- trunk/AGRIF/LIB/fortran.y	(revision 530)
+++ trunk/AGRIF/LIB/fortran.y	(revision 663)
@@ -740,25 +787,20 @@
                          /*    subroutines declaration and add it in the      */
                          /*    global declarations                            */
-                         if ( aftercontainsdeclare == 1 ) 
+                         if ( aftercontainsdeclare == 1 &&
+                              SaveDeclare == 1 && firstpass == 1 )
                          {
-                            ajoutevarsave_1($1);
-                            if ( VariableIsParameter == 0 && SaveDeclare == 1) 
-                            {
-                               pos_end = setposcur();
-                               RemoveWordSET_0(fortranout,pos_cur,
-                                               pos_end-pos_cur);
-                            }
+                              if ( inmodulemeet == 0 ) Add_Save_Var_dcl_1($1);
+                              else  Add_SubroutineDeclarationSave_Var_1($1);
                          }
                       }
-                      /* Case of common block                                 */
-                      indeclarationvar=0;
-                      PublicDeclare = 0;  
-                      PrivateDeclare = 0; 
-                      ExternalDeclare = 0; 
-                      strcpy(NamePrecision,"");  
+                      /*                                                      */
+                      PublicDeclare = 0;
+                      PrivateDeclare = 0;
+                      ExternalDeclare = 0;
+                      strcpy(NamePrecision,"");
                       c_star = 0;
                       InitialValueGiven = 0 ;
                       strcpy(IntentSpec,"");
-                      VariableIsParameter =  0 ; 
+                      VariableIsParameter =  0 ;
                       Allocatabledeclare = 0 ;
                       SaveDeclare = 0;
@@ -767,90 +809,74 @@
                       dimsgiven=0;
                       c_selectorgiven=0;
-                      strcpy(nameinttypename,"");  
-                   }
-      | TOK_FUNCTION TOK_NAME arglist
-                   {
-                      infunctiondeclare = 1 ;
-                      Listofvariableinagriffunction=(listnom *)NULL;
+                      strcpy(nameinttypename,"");
+                      strcpy(c_selectorname,"");
+                   }
+      | before_function name_routine arglist
+                   {
+                      /* open param file                                      */
+                      if ( firstpass == 0 )
+                      {
+                         sprintf(ligne,"%s/ParamFile%s.h",nomdir,$2);
+                         paramout=fopen(ligne,"w");
+                         if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                         else fprintf(paramout,"C\n");
+                      }
                       strcpy(subroutinename,$2);
                       if ( inmodulemeet == 1 )
                       {
-                         tmpdeclaration_everdone = 0;
-                         paramdeclaration_everdone = 0;
                          insubroutinedeclare = 1;
-                         AddUseAgrifUtil_0();
                          /* we should to list of the subroutine argument the  */
                          /*    name of the function which has to be defined   */
-                         if ( firstpass == 1 ) 
-                         {
-                            curvar=createvar($2,NULL);
-                            strcpy(curvar->typevar,DeclType);
-                            curlistvar=insertvar(NULL,curvar);
-                            listargsubroutine = AddListvarToListvar
-                                               (curlistvar,listargsubroutine,1);
-                            curvar=createvar($2,NULL);
-                            strcpy(curvar->typevar,DeclType);
-                            strcpy(curvar->modulename,subroutinename);
-                            curlistvar=insertvar(NULL,curvar);        
-                            varofsubroutineliste = AddListvarToListvar
-                                            (curlistvar,varofsubroutineliste,1);
-                         }
-                         if ( firstpass == 0 )
-                         {
-                            curvar=createvar($2,NULL);
-                            strcpy(curvar->typevar,DeclType);
-                            functionlistvar=insertvar(NULL,curvar);
-                         }
+                         Add_SubroutineArgument_Var_1($3);
+                         Add_FunctionType_Var_1($2);
                          /* in the second step we should write the head of    */
                          /*    the subroutine sub_loop_<subroutinename>       */
                          writeheadnewsub_0(2);
-                         adduseagrifutil = 0 ; 
                       }
                       else
                       {
-                         tmpdeclaration_everdone = 0;
-                         paramdeclaration_everdone = 0;
                          insubroutinedeclare = 1;
-                         AddUseAgrifUtil_0();
                          /* we should to list of the subroutine argument the  */
                          /*    name of the function which has to be defined   */
-                         if ( firstpass == 1 ) 
-                         {
-                            curvar=createvar($2,NULL);
-                            strcpy(curvar->typevar,DeclType);
-                            curlistvar=insertvar(NULL,curvar);
-                            listargsubroutine = AddListvarToListvar
-                                               (curlistvar,listargsubroutine,1);
-                            curvar=createvar($2,NULL);
-                            strcpy(curvar->typevar,DeclType);
-                            strcpy(curvar->modulename,subroutinename);
-                            curlistvar=insertvar(NULL,curvar);        
-                            varofsubroutineliste = AddListvarToListvar
-                                            (curlistvar,varofsubroutineliste,1);
-                         }
+                         Add_SubroutineArgument_Var_1($3);
+                         Add_FunctionType_Var_1($2);
                          /* in the second step we should write the head of    */
                          /*    the subroutine sub_loop_<subroutinename>       */
                          writeheadnewsub_0(2);
-                         adduseagrifutil = 0 ; 
-                      }
-                   }
-      ;
+                      }
+                   }
+      ;
+before_function : TOK_FUNCTION
+                   {
+                       functiondeclarationisdone = 1;
+                   }
+                   ;
+
 before_parameter : TOK_PARAMETER
                    {
+                      VariableIsParameter = 1;
                       pos_curparameter = setposcur()-9;
-                   }      
+                   }
 before_data : TOK_DATA
                    {
-                      pos_curdata = setposcur()-4;
+                      pos_curdata = setposcur()-strlen($1);
                    }
 data: TOK_NAME TOK_SLASH datavallist TOK_SLASH
                    {
-                      sprintf(ligne,"(/ %s /)",$3);
-                      CompleteDataList($1,ligne);
+                      if ( couldaddvariable == 1 )
+                      {
+                      if ( aftercontainsdeclare == 1 ) strcpy(ligne,"");
+                      else sprintf(ligne,"(/ %s /)",$3);
+                      Add_Data_Var_1($1,ligne);
+                      }
                    }
       | data opt_comma TOK_NAME TOK_SLASH datavallist TOK_SLASH
                    {
-                      sprintf(ligne,"(/ %s /)",$5);
-                      CompleteDataList($3,ligne);
+                      if ( couldaddvariable == 1 )
+                      {
+                      if ( aftercontainsdeclare == 1 ) strcpy(ligne,"");
+                      else sprintf(ligne,"(/ %s /)",$5);
+                      Add_Data_Var_1($3,ligne);
+                      }
                    }
       | datanamelist TOK_SLASH datavallist TOK_SLASH
@@ -865,43 +891,61 @@
                    }
       ;
+datavallist : expr_data
+                   {
+                      if ( couldaddvariable == 1 )
+                      {
+                         strcpy($$,$1);
+                      }
+                   }
+      | expr_data ',' datavallist
+                   {
+                      if ( couldaddvariable == 1 )
+                      {
+                         sprintf($$,"%s,%s",$1,$3);
+                      }
+                   }
+      ;
+
+save:  before_save varsave
+      | before_save  comblock varsave
+      | save opt_comma comblock opt_comma varsave
+      | save ',' varsave
+      ;
+before_save : TOK_SAVE
+                  {
+                     pos_cursave = setposcur()-4;
+                  }
+      ;
+varsave:
+      | TOK_NAME dims
+                  {
+                     if ( couldaddvariable == 1 ) Add_Save_Var_1($1,$2);
+                  }
+      ;
 datanamelist : TOK_NAME
-      | datanamelist ',' TOK_NAME
-      ;
-datavallist : expr_data
-                   {
-                      strcpy($$,$1);
-                   }
-      | expr_data ',' datavallist 
-                   {
-                      sprintf($$,"%s,%s",$1,$3);
-                   }
+      | TOK_NAME '(' expr ')'
+      | datanamelist ',' datanamelist
       ;
 expr_data : opt_signe simple_const
-                   {sprintf($$,"%s%s",$1,$2);}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s%s",$1,$2);}
       | expr_data '+' expr_data
-                   {sprintf($$,"%s+%s",$1,$3);}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s+%s",$1,$3);}
       | expr_data '-' expr_data
-                   {sprintf($$,"%s-%s",$1,$3);}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s-%s",$1,$3);}
       | expr_data '*' expr_data
-                   {sprintf($$,"%s*%s",$1,$3);}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s*%s",$1,$3);}
       | expr_data '/' expr_data
-                   {sprintf($$,"%s/%s",$1,$3);}
-      ;
-opt_signe : 
-                   {strcpy($$,"");}
+                   {if ( couldaddvariable == 1 ) sprintf($$,"%s/%s",$1,$3);}
+      ;
+opt_signe :
+                   {if ( couldaddvariable == 1 ) strcpy($$,"");}
       | signe
-                   {strcpy($$,$1);}
+                   {if ( couldaddvariable == 1 ) strcpy($$,$1);}
       ;
 namelist:  namelist_action after_namelist
       ;
-namelist_action : TOK_NAMELIST  ident 
+namelist_action : TOK_NAMELIST  ident
       | TOK_NAMELIST  comblock ident
-      {
-         AddNameToListNamelist_1($2);
-      }
       | namelist_action opt_comma comblock opt_comma ident
-      {
-         AddNameToListNamelist_1($3);
-      }
       | namelist_action ',' ident
       ;
@@ -911,41 +955,24 @@
       | TOK_ENDINTERFACE opt_name
       ;
-dimension: TOK_DIMENSION  opt_comma TOK_NAME dims lengspec
+before_dimension : TOK_DIMENSION
+                   {
+                      positioninblock=0;
+                      pos_curdimension = setposcur()-9;
+                   }
+
+dimension:  before_dimension opt_comma TOK_NAME dims lengspec
       {
          if ( couldaddvariable == 1 )
          {
-            if ( inmoduledeclare == 1 || SaveDeclare == 1 )
-            {
-               if ( AllocShouldMadeInModule() == 1 ) 
-               {
-                 AllocTo1InModule_1();
-               }
-            }      
             /*                                                                */
             curvar=createvar($3,$4);
             /*                                                                */
-            if ( IsVariableReal($3) == 1 )
-            {
-               /*                                                             */
-               CreateAndFillin_Curvar("REAL",$3,$4,curvar);
-               /*                                                             */
-               curlistvar=insertvar(NULL,curvar);
-               /*                                                             */
-               $$=settype("REAL",curlistvar);
-            }
-            else
-            {
-               /*                                                             */
-               CreateAndFillin_Curvar("INTEGER",$3,$4,curvar);
-               /*                                                             */
-               curlistvar=insertvar(NULL,curvar);
-               /*                                                             */
-               $$=settype("INTEGER",curlistvar);
-            }
+            CreateAndFillin_Curvar("",curvar);
+            /*                                                                */
+            curlistvar=insertvar(NULL,curvar);
+            /*                                                                */
+            $$=settype("",curlistvar);
+            /*                                                                */
             strcpy(vallengspec,"");
-         }
-         else
-         {
-            /* mazauric*/
          }
       }
@@ -957,27 +984,11 @@
             curvar=createvar($3,$4);
             /*                                                                */
-            if ( IsVariableReal($3) == 1 )
-            {
-               /*                                                             */
-               CreateAndFillin_Curvar("REAL",$3,$4,curvar);
-               /*                                                             */
-               curlistvar=insertvar($1,curvar);
-               /*                                                             */
-               $$=curlistvar;
-            }
-            else
-            {
-               /*                                                             */
-               CreateAndFillin_Curvar("INTEGER",$3,$4,curvar);
-               /*                                                             */
-               curlistvar=insertvar($1,curvar);
-               /*                                                             */
-               $$=curlistvar;
-            }
+            CreateAndFillin_Curvar("",curvar);
+            /*                                                                */
+            curlistvar=insertvar($1,curvar);
+            /*                                                                */
+            $$=curlistvar;
+            /*                                                                */
             strcpy(vallengspec,"");
-         }         
-         else
-         {
-            /* mazauric*/
          }
       }
@@ -987,18 +998,14 @@
       ;
 public: TOK_PUBLIC '\n'
-      | TOK_PUBLIC opt_sep use_name_list 
-      ;
-use_name_list: TOK_NAME 
+      | TOK_PUBLIC opt_sep use_name_list
+      ;
+use_name_list: TOK_NAME
       | use_name_list ',' TOK_NAME
       ;
 common: before_common var_common_list
                    {
-                         if (fortran77 == 1 &&
-                             couldaddvariable == 1 )
-                         {
-                            pos_end = setposcur();
-                            RemoveWordSET_0(fortranout,pos_curcommon,
+                         pos_end = setposcur();
+                         RemoveWordSET_0(fortranout,pos_curcommon,
                                                   pos_end-pos_curcommon);
-                         }
                    }
       | before_common comblock var_common_list
@@ -1007,11 +1014,8 @@
                          {
                             sprintf(charusemodule,"%s",$2);
-                            Add_ModuleTo_Modulelist_1($2);
-                            if ( fortran77 == 1 )
-                            {
-                               pos_end = setposcur();
-                               RemoveWordSET_0(fortranout,pos_curcommon,
-                                                     pos_end-pos_curcommon);
-                            }
+                            Add_NameOfCommon_1($2);
+                            pos_end = setposcur();
+                            RemoveWordSET_0(fortranout,pos_curcommon,
+                                                       pos_end-pos_curcommon);
                          }
                    }
@@ -1021,11 +1025,8 @@
                          {
                             sprintf(charusemodule,"%s",$3);
-                            Add_ModuleTo_Modulelist_1($3);
-                            if ( fortran77 == 1 )
-                            {
-                               pos_end = setposcur();
-                               RemoveWordSET_0(fortranout,pos_curcommon,
-                                                     pos_end-pos_curcommon);
-                            }
+                            Add_NameOfCommon_1($3);
+                            pos_end = setposcur();
+                            RemoveWordSET_0(fortranout,pos_curcommon,
+                                                       pos_end-pos_curcommon);
                          }
                    }
@@ -1044,14 +1045,14 @@
 var_common_list : var_common
                    {
-                      if ( couldaddvariable == 1 ) Addtolistvarcommon();
+                      if ( couldaddvariable == 1 ) Add_Common_var_1();
                    }
 
      | var_common_list ',' var_common
                    {
-                      if ( couldaddvariable == 1 ) Addtolistvarcommon();
-                   }
-var_common: TOK_NAME dims  
-                   {
-                      if ( couldaddvariable == 1 ) 
+                      if ( couldaddvariable == 1 ) Add_Common_var_1();
+                   }
+var_common: TOK_NAME dims
+                   {
+                      if ( couldaddvariable == 1 )
                       {
                          positioninblock = positioninblock + 1 ;
@@ -1061,7 +1062,7 @@
                    }
       ;
-comblock: TOK_DSLASH 
-                   {
-                      if ( couldaddvariable == 1 ) 
+comblock: TOK_DSLASH
+                   {
+                      if ( couldaddvariable == 1 )
                       {
                          strcpy($$,"");
@@ -1070,7 +1071,7 @@
                       }
                    }
-      | TOK_SLASH TOK_NAME TOK_SLASH 
-                   {
-                      if ( couldaddvariable == 1 ) 
+      | TOK_SLASH TOK_NAME TOK_SLASH
+                   {
+                      if ( couldaddvariable == 1 )
                       {
                          strcpy($$,$2);
@@ -1080,14 +1081,4 @@
                    }
       ;
-save: TOK_SAVE varsave
-      | TOK_SAVE  comblock varsave
-      | save opt_comma comblock opt_comma varsave
-      | save ',' varsave
-      ;
-varsave: 
-      | TOK_NAME before_dims dims 
-      {created_dimensionlist = 1;}
-      ;
-      
 opt_comma:
       | ','
@@ -1095,20 +1086,25 @@
 paramlist: paramitem
                    {
-                      if ( firstpass == 1 ) $$=insertvar(NULL,$1);
+                      if ( couldaddvariable == 1 ) $$=insertvar(NULL,$1);
                    }
       | paramlist ',' paramitem
                    {
-                      if ( firstpass == 1 ) $$=insertvar($1,$3);
+                      if ( couldaddvariable == 1 ) $$=insertvar($1,$3);
                    }
       ;
 paramitem : TOK_NAME '=' expr
                    {
-                      if ( firstpass == 1 )
-                      {
+                     if ( couldaddvariable == 1 )
+                     {
                          curvar=(variable *) malloc(sizeof(variable));
-                         strcpy(curvar->nomvar,$1);
-                         strcpy(curvar->subroutinename,subroutinename);
-                         strcpy(curvar->modulename,subroutinename);
-                         strcpy(curvar->initialvalue,$3);
+                         /*                                                   */
+                         Init_Variable(curvar);
+                         /*                                                   */
+                         curvar->v_VariableIsParameter=1;
+                         strcpy(curvar->v_nomvar,$1);
+                         strcpy(curvar->v_subroutinename,subroutinename);
+                         strcpy(curvar->v_modulename,curmodulename);
+                         strcpy(curvar->v_initialvalue,$3);
+                         strcpy(curvar->v_commoninfile,mainfile);
                          $$=curvar;
                       }
@@ -1122,15 +1118,10 @@
 implicit: TOK_IMPLICIT TOK_NONE
                     {
-                       if ( firstpass == 1 && insubroutinedeclare == 1 )
-                       {
-                           listimplicitnone = Addtolistname
-                                              (subroutinename,listimplicitnone);
-                       }
-                       if ( tmpdeclaration_everdone == 1 && 
-                            inmoduledeclare == 0 )
-                       {
-                         pos_end = setposcur();
-                         RemoveWordSET_0(fortranout,pos_end-13,
-                                               13);
+                       if ( insubroutinedeclare == 1 )
+                       {
+                          Add_ImplicitNoneSubroutine_1();
+                          pos_end = setposcur();
+                          RemoveWordSET_0(fortranout,pos_end-13,
+                                                             13);
                        }
                     }
@@ -1143,13 +1134,6 @@
                       if ( couldaddvariable == 1 )
                       {
-                         if ( inmoduledeclare == 1 || SaveDeclare == 1 )
-                         {
-                            if ( AllocShouldMadeInModule() == 1 ) 
-                            {
-                               AllocTo1InModule_1();
-                            }
-                         }      
                          /*                                                   */
-                         if (dimsgiven == 1) 
+                         if (dimsgiven == 1)
                          {
                             curvar=createvar($3,curdim);
@@ -1160,10 +1144,10 @@
                          }
                          /*                                                   */
-                         CreateAndFillin_Curvar(DeclType,$3,$4,curvar);
+                         CreateAndFillin_Curvar(DeclType,curvar);
                          /*                                                   */
                          curlistvar=insertvar(NULL,curvar);
-                         if (!strcasecmp(DeclType,"character")) 
+                         if (!strcasecmp(DeclType,"character"))
                          {
-                            if (c_selectorgiven == 1) 
+                            if (c_selectorgiven == 1)
                             {
                                strcpy(c_selectordim.first,"1");
@@ -1175,8 +1159,4 @@
                          $$=settype(DeclType,curlistvar);
                       }
-                      else
-                      {
-                         /* mazauric*/
-                      }
                       strcpy(vallengspec,"");
                    }
@@ -1185,5 +1165,5 @@
                       if ( couldaddvariable == 1 )
                       {
-                         if (dimsgiven == 1) 
+                         if (dimsgiven == 1)
                          {
                             curvar=createvar($4,curdim);
@@ -1193,13 +1173,13 @@
                             curvar=createvar($4,$5);
                          }
-                         /*                                                   */ 
-                         CreateAndFillin_Curvar($1->var->typevar,$4,$5,curvar);
                          /*                                                   */
-                         strcpy(curvar->typevar,($1->var->typevar));
+                         CreateAndFillin_Curvar($1->var->v_typevar,curvar);
+                         /*                                                   */
+                         strcpy(curvar->v_typevar,($1->var->v_typevar));
                          /*                                                   */
                          curlistvar=insertvar($1,curvar);
-                         if (!strcasecmp(DeclType,"character")) 
+                         if (!strcasecmp(DeclType,"character"))
                          {
-                            if (c_selectorgiven == 1) 
+                            if (c_selectorgiven == 1)
                             {
                                strcpy(c_selectordim.first,"1");
@@ -1211,40 +1191,41 @@
                          $$=curlistvar;
                       }
-                      else
-                      {
-                         /* mazauric*/
-                      }
                       strcpy(vallengspec,"");
                    }
-      ;      
+      ;
 nodimsgiven:       {dimsgiven=0;}
       ;
-type:typespec selector 
-                   {strcpy(DeclType,$1);indeclarationvar=1;}
-      | before_character c_selector 
-                   {
-                      indeclarationvar=1;
+type:typespec selector
+                   {strcpy(DeclType,$1);}
+      | before_character c_selector
+                   {
                       strcpy(DeclType,"CHARACTER");
-                      if (inmoduledeclare == 1 ) 
-                      {
-                         AllocShouldMadeTo1InModule_1();
-                      }
                    }
       | typename '*' TOK_CSTINT
                    {
-                      indeclarationvar=1;
                       strcpy(DeclType,$1);
                       strcpy(nameinttypename,$3);
                    }
+      | before_typepar attribute ')'
+                   {
+                      strcpy(DeclType,"TYPE");
+                   }
+      ;
+before_typepar : TOK_TYPEPAR
+                   {
+                      if ( couldaddvariable == 1 ) VarTypepar = 1 ;
+                      couldaddvariable = 0 ;
+                      pos_cur_decl = setposcur()-5;
+                   }
       ;
 c_selector:
-      | '*' TOK_CSTINT 
+      | '*' TOK_CSTINT
                    {c_selectorgiven=1;strcpy(c_selectorname,$2);}
       | '*' '(' c_attribute ')' {c_star = 1;}
-      | '(' c_attribute ')' 
-      ;
-c_attribute: TOK_NAME clause opt_clause 
-      | TOK_NAME '=' clause opt_clause 
-      | clause opt_clause 
+      | '(' c_attribute ')'
+      ;
+c_attribute: TOK_NAME clause opt_clause
+      | TOK_NAME '=' clause opt_clause
+      | clause opt_clause
       ;
 before_character : TOK_CHARACTER
@@ -1255,40 +1236,27 @@
 typespec: typename {strcpy($$,$1);}
       ;
-typename: TOK_INTEGER 
+typename: TOK_INTEGER
                    {
                       strcpy($$,"INTEGER");
                       pos_cur_decl = setposcur()-7;
-                      if (inmoduledeclare == 1 ) 
-                      {
-                         AllocShouldMadeTo1InModule_1();
-                       }
                    }
       | TOK_REAL   {
-                      strcpy($$,"REAL"); 
+                      strcpy($$,"REAL");
                       pos_cur_decl = setposcur()-4;
-                      if (inmoduledeclare == 1 ) 
-                      {
-                         AllocShouldMadeTo1InModule_1();
-                      }
-                   }
-      | TOK_COMPLEX      
+                   }
+      | TOK_COMPLEX
                    {strcpy($$,"COMPLEX");}
-      | TOK_DOUBLEPRECISION 
-                   {strcpy($$,"DOUBLE PRECISION");}
-      | TOK_DOUBLECOMPLEX 
+      | TOK_DOUBLEPRECISION
+                   {
+                      pos_cur_decl = setposcur()-16;
+                      strcpy($$,"REAL");
+                      strcpy(nameinttypename,"8");
+                   }
+      | TOK_DOUBLECOMPLEX
                    {strcpy($$,"DOUBLE COMPLEX");}
-      | TOK_LOGICAL      
+      | TOK_LOGICAL
                    {
                       strcpy($$,"LOGICAL");
                       pos_cur_decl = setposcur()-7;
-                      if (inmoduledeclare == 1 ) 
-                      {
-                         AllocShouldMadeTo1InModule_1();
-                      }
-                   }
-      | TOK_TYPE      
-                   {
-                      pos_cur_decl = setposcur()-5;
-                      strcpy($$,"TYPE");
                    }
       ;
@@ -1301,21 +1269,26 @@
 selector:
       | '*' proper_selector
-      | '(' attribute ')' 
+      | '(' attribute ')'
       ;
 proper_selector: expr
       | '(' '*' ')'
       ;
-attribute: TOK_NAME clause 
-      | TOK_NAME '=' clause  
-                   {
-                      sprintf(NamePrecision,"%s = %s",$1,$3);  
+attribute: TOK_NAME clause
+      | TOK_NAME '=' clause
+                   {
+                      if ( strstr($3,"0.d0") )
+                      {
+                         strcpy(nameinttypename,"8");
+                         sprintf(NamePrecision,"");
+                      }
+                      else sprintf(NamePrecision,"%s = %s",$1,$3);
                    }
       | TOK_NAME
                    {
-                      strcpy(NamePrecision,$1);  
+                      strcpy(NamePrecision,$1);
                    }
       | TOK_CSTINT
                    {
-                      strcpy(NamePrecision,$1);  
+                      strcpy(NamePrecision,$1);
                    }
       ;
@@ -1323,7 +1296,7 @@
                     strcpy($$,$1);}
       | '*'        {strcpy(CharacterSize,"*");
-                    strcpy($$,"*");} 
-      ;
-opt_clause: 
+                    strcpy($$,"*");}
+      ;
+opt_clause:
       | ',' TOK_NAME clause
       ;
@@ -1335,22 +1308,18 @@
       | attr_spec_list ',' attr_spec
       ;
-attr_spec: TOK_PARAMETER 
+attr_spec: TOK_PARAMETER
                    {
                       VariableIsParameter = 1;
-                      if (inmoduledeclare == 1 ) 
-                      {
-                         AllocShouldMadeTo0InModule_1();
-                      }
                    }
       | access_spec
-      | TOK_ALLOCATABLE 
+      | TOK_ALLOCATABLE
                    {Allocatabledeclare = 1;}
-      | TOK_DIMENSION dims 
-                   {
-                      dimsgiven=1; 
+      | TOK_DIMENSION dims
+                   {
+                      dimsgiven=1;
                       curdim=$2;
                    }
-      | TOK_EXTERNAL  
-                   {ExternalDeclare = 1;} 
+      | TOK_EXTERNAL
+                   {ExternalDeclare = 1;}
       | TOK_INTENT intent_spec
                    {strcpy(IntentSpec,$2);}
@@ -1359,10 +1328,8 @@
       | TOK_POINTER {pointerdeclare = 1 ;}
       | TOK_SAVE    {
-                       if ( inmodulemeet == 1 )
-                       {
+/*                       if ( inmodulemeet == 1 )
+                       {*/
                           SaveDeclare = 1 ;
-                          Savemeet = 1;
-                          AllocShouldMadeTo1InModule_1();
-                       }
+                     /*  }*/
                     }
       | TOK_TARGET
